#!/usr/bin/env perl
use strict;
use warnings;

my $lang = '';
my %data;
my ($all, $same) = (0, 0);

while (<>){ 
    s/[\r\n]+$//;
    if (/<\/tu>/){
        my ($trans, $cleaner, $found) = ($data{TRANS}, $data{CLEANER}, $data{FOUND});

        if ($cleaner !~ /(^LANG-|DO NOT TRANSLATE)/ && $trans ne ''){
            $cleaner =~ s/&lt;(REACCENTED|OFFENSIVE)&gt;//g;
            $trans =~ s/&lt;OFFENSIVE&gt;//;
            $cleaner =~ s/(^\s+|\s+$)//g;
            $trans =~ s/(^\s+|\s+$)//g;
            $found =~ s/(^\s+|\s+$)//g;

            $all++;
            $same++ if $found eq $cleaner;

            my $line = "$data{segorder}\t$found\t$cleaner\t$trans\n";
            $line =~ s/&quot;/"/g;
            $line =~ s/&apos;/'/g;
            $line =~ s/&gt;/>/g;
            $line =~ s/&lt;/</g;
            $line =~ s/&amp;/&/g;
            print $line;
        }
        %data = ();
    } elsif (/<prop type="x-TXT:segorder">([^<]+)/){ 
        $data{segorder} = $1;
    } elsif (/<tuv xml:lang="([^"]+)"/){
        $lang = $1;
    } elsif (/<seg \/>/){
        $data{$lang} = '';
    } elsif (/<seg>(.*)<\/seg>$/){
        $data{$lang} = $1;
    } elsif  (/^<seg>(.*)$/){
        $data{$lang} = $1;
        $_ = '';
        while ($_ !~ /<\/seg>$/){
            $data{$lang} .= $_;
            $_ = <>;
            s/[\r\n]+$//;
        }
        /(.*)<\/seg>$/;
        $data{$lang} .= $1;
    }
}
warn sprintf("Same $same out of $all (%d%%)\n", 100*$same/$all);
